c compute colour evolution from template SEDs
c Last modif: 
c November 27, 2007: added factors to have apparent magnitudes 
c     normalized to 1 M_sun
c August 23, 2012: general revision   
c July 09, 2013: new revision according to revised recipes in hyperz   
c December 2016 - April 2017: bug fixes
c August 2017: added stellar mass for ised files
      PROGRAM colour_track
      IMPLICIT NONE
      INTEGER mxwf,mxfil,input,nparam,i,nz,iz,ii,iii,j,k,l,kfil,nfil,
     &     iblank,itype,mxtyp,mxtyp_bc,mxtyp_as,mxtyp_pg,iw,last,np,
     &     ncomp,n_filt,n_files,mag_typ,ks,i1,i2,lyf,iw_vega,
     &     law_rd,iband,iseg,imf,jo,ic1,mxvega,mxafil,mxlyf,
     &     mxred,mxwl_bc,mxwl_pg,mxwl_as,mxwl,mxage_bc,mxage_pg,mxage,
     &     mxrp,i_bc,i_pg,i_as,ntyp_bc,ntyp_pg,ntyp_as,it_pg,nemline,
     &     ifilt,ifilt2,iage_typ,norm_filt,ifilt_n
      REAL*8 y,yob,amag,dz,t_bc,h0,om,ov,r,surf,wl,z0,c,
     &     av,w_vega,f_vega,flux,z,vega,z_max,z_min,z_form,filter,ww,
     &     conv_mag,bp1,tz,age_form,age_uni,age_z,age_gal0,age_galz,age,
     &     tx,t1,t2,a1,a2,trapz1,rlin,fact_lyf,dl,d_l,scl,
     &     factmass,pi4,lsun,wlmin,wlmax,aa8,amgal,amstar,sfr,t_pg,
     &     fff,rr2,f2,tau,f_bc,f_pg,f_as,f,xlam,age_fix,
     &     starmass,galmass,sfrgal,rnorm,amag_norm,b,fl_n,xh8
      REAL w_bc,t_bc0,w_as,w_pg,wv,fv,aa,ff,xh
      PARAMETER (nparam=23,pi4=3.141592654D0*4.D0,imf=10,lsun=3.826D33)
      PARAMETER (c=2.99792458D+18) ! speed of light in AA/s)
      INCLUDE 'dimensionz.dec'
      PARAMETER (mxtyp=mxtyp_bc+mxtyp_as+mxtyp_pg)
      REAL ml,mu,xx(imf),lm(imf),um(imf),baux(imf),cn(imf),cc(imf),totm,
     &     totn,avs,tau0,zsun
      CHARACTER filesed(mxtyp)*160,line*160
      CHARACTER*40 cname,param(nparam),sed_abc(mxtyp)*2
      CHARACTER mags(mxfil)*15,ch(mxfil)*3
      CHARACTER*160 spectra1,filein,filt_file,fmt,fmt0,filedef,line_sed,
     &     spec_vega,filtresfile,filered
      CHARACTER date*24,cmag*5,line_pg*80,string_id*80

      DIMENSION input(nparam),kfil(10),ks(mxtyp)
      DIMENSION ntyp_bc(mxtyp),ntyp_as(mxtyp),ntyp_pg(mxtyp)
      DIMENSION tau(mxtyp),zsun(mxtyp)
      DIMENSION nfil(mxfil),iw(mxtyp),iband(mxfil)
      DIMENSION t_bc0(mxage_bc),t_bc(mxage_bc),t_pg(mxage_pg),ff(mxwl)
      DIMENSION w_vega(mxvega),f_vega(mxvega),vega(mxfil)
      DIMENSION bp1(mxfil),conv_mag(mxfil),surf(mxfil),f2(mxfil)
      DIMENSION amag(mxfil),wl(mxfil)
      DIMENSION y(mxwl),yob(mxwl),ww(mxwl)
      DIMENSION w_bc(mxwl_bc,mxtyp_bc),f_bc(mxwl_bc,mxage_bc,mxtyp_bc)
      DIMENSION w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,1,mxtyp_as)
      DIMENSION w_pg(mxwl_pg,mxtyp_pg),f_pg(mxwl_pg,mxage_pg,mxtyp_pg)
      DIMENSION xlam(mxwf),rr2(mxwf),f(mxwl,mxage)
      DIMENSION xh(mxage_bc),xh8(mxage_bc),amstar(mxtyp_bc,mxage_bc),
     .     amgal(mxtyp_bc,mxage_bc),sfr(mxtyp_bc,mxage_bc)

      EXTERNAL filter,tz,rlin,trapz1,d_l
c
      COMMON/compose/ifilt,np(mxfil+mxafil)
      COMMON/rfilter/r(mxwf,mxfil+mxafil,2)
      COMMON/filterres/filtresfile
      COMMON/redfile/filered
      COMMON/lyf_sigma/fact_lyf
c_________________________________________________________________________

      DO i=1,mxfil
         iband(i)=1       ! bandpass response function unit for each filter
                          ! 0.energy; 1.photons (see e.g. Bessell 2005)
                          ! this is not a free parameter, if you need to change
                          ! it modify the value here and recompile
      END DO
      fact_lyf=1.D0
      z0=0.D0             ! redshift 0
c factmass = factor taking into account the normalisation in solar units in 
c Bruzual & Charlot models and the conversion from distances in Mpc to cm 
      factmass=pi4*3.085678D0*3.085678D48/lsun

      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='TEMPLATES_FILE'
      param(4)='FILTERS_FILE'
      param(5)='MAG_TYPE'
      param(6)='H_0'
      param(7)='OMEGA_M'
      param(8)='OMEGA_V'
      param(9)='Z_FORM'
      param(10)='Z_MIN'
      param(11)='Z_MAX'
      param(12)='Z_STEP'
      param(13)='LY_FOREST'
      param(14)='FACT_LYF'
      param(15)='FILE_OUT'
      param(16)='A_V'
      param(17)='REDDENING_LAW'
      param(18)='FILE_EXT_LAW'
      param(19)='TRANS_TYPE'
      param(20)='AGE'
      param(21)='AGE_FIX'
      param(22)='NORM_FILT'
      param(23)='MAG_NORM'

      DO i=1,nparam
         input(i)=0
      END DO

 44   filein='colourmass_tracks.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file' 
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ (*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)') filein
      END IF

      OPEN(77,FILE=filein,STATUS='old',ERR=44)
 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c ..... A0VSED file
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c .... FILTER.RES file
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing templates names
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') filedef
         input(3)=1
         GO TO 7
c ..... File containing filters
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filt_file
         input(4)=1
         GO TO 7
c ..... Magnitude type: 0. Vega 1. AB
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) mag_typ
         IF (mag_typ.ne.0.and.mag_typ.ne.1) THEN
            WRITE(*,*) 'MAG_TYPE must be 0 or 1'
            STOP
         END IF
         IF (mag_typ.eq.0) THEN
            cmag='Vega'
         ELSE IF (mag_typ.eq.1) THEN
            cmag='AB'
         ELSE IF (mag_typ.eq.2) THEN ! not implemented yet
            cmag='muJy'
         END IF
         input(5)=1
         GO TO 7
c ..... Cosmological parameters: H_0, Omega_0, Omega_Lambda
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) h0
         INPUT(6)=1
         GO TO 7
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) om
         INPUT(7)=1
         GO TO 7
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) ov
         INPUT(8)=1
         GO TO 7
c ..... Formation redshift
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) z_form
         INPUT(9)=1
         GO TO 7
c ..... Redshift range and step
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) z_min
         INPUT(10)=1
         GO TO 7
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) z_max
         INPUT(11)=1
         GO TO 7
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) dz
         INPUT(12)=1
         GO TO 7
c ..... Lyman forest
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,*) lyf
         INPUT(13)=1
         GO TO 7
c .... lyman forst factor with respect to Madau's estimate
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,*) fact_lyf
         input(14)=1
         GO TO 7
c ..... output file 
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,'(A)') spectra1
         input(15)=1
         GO TO 7
c ..... reddening
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,*) av
         INPUT(16)=1
         GO TO 7
c ..... Reddening:
c       0 -> No reddening
c       1 -> Allen, 1976, standard MW
c       2 -> Seaton, 1979, standard MW
c       3 -> Fitzpatrick, 1986, LMC
c       4 -> Prevot, 1984 + Bouchet, 1985, SMC
c       5 -> Calzetti et al., 2000
c      -1 -> user provided table with lambda[A],k(lambda)/RV
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) law_rd
         IF (law_rd.ne.0.and.law_rd.ne.1.and.law_rd.ne.2.and.
     .        law_rd.ne.3.and.law_rd.ne.4.and.law_rd.ne.5.and.
     .        law_rd.ne.-1) THEN
            WRITE(*,*) 'REDDENING_LAW must be -1 -- 5'
            STOP
         END IF
         input(17)=1
         GO TO 7
c ..... File containing used provided extinction law (lambda[A],k(lambda)/RV)
      ELSE IF (cname.eq.param(18)) THEN
         READ(line,'(A)') filered
         input(18)=1
         GO TO 7
      ELSE IF (cname.eq.param(19)) THEN
c ..... Transmission of output filters (max mxfil): 
c       0. energy 1. photons
         ifilt2=1
         DO k=1,160
            IF (line(k:k).eq.',') THEN
               line(k:k)=' '
               ifilt2=ifilt2+1
            END IF
            IF (line(k:k).eq.'#') THEN ! end of filters' list
               line=line(1:k-1)
               GO TO 888
            END IF
         END DO
 888     READ(line,*) (iband(k),k=1,ifilt2)
         input(19)=1
         GO TO 7
c ..... Age choice: meaningful only in case of evolving templates 
c 0. fixed age: AGE_FIX parameter must be specified
c 1. evolving: Z_FORM parameter must be specified
      ELSE IF (cname.eq.param(20)) THEN
         READ(line,*) iage_typ
         input(20)=1
         GO TO 7
c ..... Fixed age in case AGE=0 (only for evolving templates)
c In this case 
      ELSE IF (cname.eq.param(21)) THEN
         READ(line,*) age_fix
         input(21)=1
         GO TO 7
c ..... Normalisation filter 
      ELSE IF (cname.eq.param(22)) THEN
         READ(line,*) norm_filt
         input(22)=1
         GO TO 7
c ..... Value of the magnitude to compute normalisation
      ELSE IF (cname.eq.param(23)) THEN
         READ(line,*) amag_norm
         input(23)=1
         GO TO 7
      ELSE 
         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)

c check parameters
      DO i=1,nparam
         IF (input(i).eq.0) THEN
            WRITE(*,*) 'Missed parameter ', param(i)
            WRITE(*,*) '(all the parameters must be specified, '
     &           //'also the optional ones)'
            STOP
         END IF
      END DO
      IF (law_rd.eq.0) av=0.

      OPEN(10,FILE=filedef,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      last=INDEX(line_sed,' ')-1
      filesed(iii)=line_sed(1:last)
      line_sed=line_sed(last+1:)
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', filesed(iii)
      STOP
 2221 sed_abc(iii)=line_sed(1:2)
      iii=iii+1
      GO TO 2230
 2220 n_files=iii-1
      IF (n_files.gt.mxtyp) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of files exceeding the maximum [max=',mxtyp,']'
         STOP
      END IF
      WRITE(*,'(1x,a,1x,i4,1x,a)') 'There are ',n_files,
     &     ' synthetic spectra'
      CLOSE(10)

c filters
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)
      ifilt=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      ifilt=ifilt+1
      ncomp=1
      READ(line,*,ERR=82) nfil(ifilt)
      kfil(1)=nfil(ifilt)
c read_filt subroutine 
      CALL read_filt(ncomp,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),
     &     iband(ifilt))
      GO TO 134

 135  IF (norm_filt.gt.0) THEN
c filter for normalisation
         DO i=1,ifilt
            IF (nfil(i).eq.norm_filt) THEN
               ifilt_n=i
               GO TO 136
            END IF
         END DO
         ifilt=ifilt+1
         ifilt_n=ifilt
         kfil(1)=norm_filt
         ncomp=1
c read_filt subroutine 
      CALL read_filt(ncomp,kfil,wl(ifilt),surf(ifilt),bp1(ifilt),
     &     iband(ifilt))
      END IF

 136  n_filt=ifilt
      IF (n_filt.gt.mxfil) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of filters exceeding the maximum [max=',mxfil,']'
         STOP
      END IF
      WRITE(*,'(1x,a,1x,i4,1x,a)') 'There are ',n_filt,' filters'
      CLOSE(10)

      WRITE(fmt,1002) n_filt
 1002 FORMAT('(1x,f8.4,1x,i3,',i2,'(1x,f7.3),1x,f12.3,1x,f12.4,
     &     1x,f12.4,1X,E10.4,1X,F12.6,1X,F12.6,1X,E12.6))')

c check number of filters and number of type of transmission functions:
      IF (n_filt.ne.ifilt2.and.ifilt2.ne.1) THEN
         WRITE(*,'(a,i3,a,i3,a)') 'Number of TRANS_TYPE (=',ifilt2,
     &        ') is different from n filters (=',n_filt,')'
         STOP
c only one type of transmission function to be applied to all filters
      ELSE IF (ifilt2.eq.1.and.n_filt.gt.1) THEN
         DO k=2,n_filt
            iband(k)=iband(1)
         END DO
      END IF
c Compute flux from normalisation magnitude
c Vega mag -> erg/cm2/s/A
      IF (mag_typ.eq.0) THEN
         fl_n=vega(ifilt_n)*10**(-0.4D0*(amag_norm)/
     &        surf(ifilt_n)) 
c AB mag -> erg/cm2/s/Hz
      ELSE IF (mag_typ.eq.1) THEN
         fl_n=10**(-0.4D0*(amag_norm+48.6D0))
c muJy -> erg/cm2/s/Hz
      ELSE IF (mag_typ.eq.2) THEN
         fl_n=amag_norm*1.D-29
      END IF

c -----------------------------------------------------------------------
c                       Reading synthetic spectra 
c -----------------------------------------------------------------------
c ..... Vega
      WRITE (*,'(1x,a)') 'Vega SED:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(a)') line(1:80)
c      scl=2.D-17
      scl=1.D0
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)*scl
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,'(a,1x,i6,1x,a)') 'There are ',iw_vega,' points in Vega'

c maximum and minimum wavelength in filters
      wlmax=0.D0
      wlmin=1.D12
      DO i=1,n_filt
         wlmax=MAX(wlmax,r(np(i),i,1))
         wlmin=MIN(wlmin,r(1,i,1))
      END DO
c maximum wavelength at the maximum redshift
      wlmax=wlmax*(1.D0+z_max)
c minimum wavelength at the minimum redshift
      wlmin=wlmin*(1.D0+z_min)

c ..... SED
      WRITE(*,*) 'Reading synthetic spectra :'
      i_bc=0
      i_as=0
      i_pg=0
      DO i=1,n_files
         ntyp_bc(i)=-1
         ntyp_as(i)=-1
         ntyp_pg(i)=-1
      END DO 
   
      DO i=1,n_files
         last=INDEX(filesed(i),' ')
         WRITE(*,2005) i,filesed(i)(1:last)
c GISSEL's templates
         IF (sed_abc(i).eq.'BC') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='unformatted',ERR=25)
            i_bc=i_bc+1
            IF (i_bc.gt.mxtyp_bc) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of GISSEL templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL SEDs or modify mxtyp_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_bc(i)=i_bc
c ks = n of temporal intervals, t_bc and t_bc0 in [yr]
            READ (1) ks(i),(t_bc0(ii),ii=1,ks(i)),ml,mu,iseg,
     &           (xx(j),lm(j),um(j),baux(j),cn(j),cc(j),j=1,iseg),
     &           totm,totn,avs,jo,tau0,string_id
c replace value of tau if SFH is not exponentially declining
c SFHs following jo parameter: 
c jo=0: SSP; jo=1: exp. declining with gas recycling; 
c jo=2: burst of finite length; jo=3: constant; jo=4: exp. declining; 
c jo=5: burst added; jo=6: delayed; jo=7: input SFH; 
c jo=8: linearly decreasing
            IF (jo.eq.0) THEN   ! SSP 
               tau(i)=0.D0
            ELSE IF (jo.eq.3) THEN
               tau(i)=-1.D0     ! constant SFR
            ELSE IF (jo.eq.4.or.jo.eq.1) THEN
               tau(i)=tau0/1.D9 ! TAU models
            ELSE
               tau(i)=-10.D0    ! other SFHs
            END IF
            ic1=INDEX(string_id,'Z=')
            string_id=string_id(ic1+2:)
            READ (string_id,*) zsun(i) 
c iw = number of wavelengths, w_bc wavelength in [A]
            READ (1) iw(i),(w_bc(ii,i_bc),ii=1,iw(i)) 
            IF (iw(i).gt.mxwl_bc) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in GISSEL '
     .              //'templates exceeding the maximum. Max = ',mxwl_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL wavelenghts or modify mxwl_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (w_bc(iw(i),i_bc).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_bc(iw(i),i_bc),
     .              ' , lambda_max(z_max) should be ',wlmax
               WRITE(*,'(a)') 'Decrease z_max or change the template'
            END IF
            IF (w_bc(1,i_bc).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_bc(1,i_bc),
     .              ' , lambda_min(z_min) should be ',wlmin
               WRITE(*,'(a)') 'Increase z_min or change the template'
            END IF
            k=0
            DO j=1,ks(i)
               READ (1) iw(i),(ff(ii),ii=1,iw(i))
               t_bc(j)=DBLE(t_bc0(j))
               DO ii=1,iw(i)
                  IF (w_bc(ii,i_bc).lt.912.) THEN
                     f_bc(ii,j,i_bc)=0.D0
                  ELSE
                     f_bc(ii,j,i_bc)=DBLE(ff(ii))
                  END IF
               END DO
            END DO
c Read mass and star formation as a function of age from the last 12
c fields in .ised files
c 1.bolometric luminosity
            READ (1) ks(i),(xh(j),j=1,ks(i))
c 2.stellar mass
            READ (1) ks(i),(xh(j),j=1,ks(i))
            DO j=1,ks(i)
               amstar(i,j)=DBLE(xh(j))
            END DO
c 3.star formation (following fields are not needed here)
            READ (1) ks(i),(xh(j),j=1,ks(i))
            DO j=1,ks(i)
               sfr(i,j)=DBLE(xh(j))
               t_bc(j)=DBLE(t_bc0(j))
               xh8(j)=sfr(i,j)
            END DO
            DO j=1,ks(i)
               IF (tau(i).gt.0.D0.and.(jo.eq.1.or.jo.eq.4)) THEN
                  amgal(i,j)=(1.-DEXP(-t_bc(j)*1.D-9/tau(i))) ! for tau models
               ELSE
                  amgal(i,j)=trapz1(t_bc,xh8,j) ! valid for all SFHs
               END IF
            END DO
            CLOSE(1)

c ASCII SEDs
         ELSE IF (sed_abc(i).eq.'AS'.or.sed_abc(i).eq.'A ') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_as=i_as+1
            IF (i_as.gt.mxtyp_as) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of ASCII templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII SEDs or modify mxtyp_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_as(i)=i_as
            ks(i)=1
            ii=1

 33         READ(1,'(A)',ERR=34,END=34) line_sed
            IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 33

            READ(line_sed,*) w_as(ii,i_as),fff
c            f_as(ii,1,i_as)=DBLE(fff)
            f_as(ii,1,i_as)=fff
            ii=ii+1
            IF (ii.gt.mxwl_as) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in ASCII '
     .              //'templates exceeding the maximum. Max = ',mxwl_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII wavelenghts or modify mxwl_as in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            GO TO 33
 34         iw(i)=ii-1
            IF (w_as(iw(i),i_as).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_as(iw(i),i_as),
     .              ' , lambda_max(z_max) should be ',wlmax
               WRITE(*,'(a)') 'Decrease z_max or change the template'
            END IF
            IF (w_as(1,i_as).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_as(1,i_as),
     .              ' , lambda_min(z_min) should be ',wlmin
               WRITE(*,'(a)') 'Increase z_min or change the template'
            END IF
            CLOSE(1)

c PEGASE templates
         ELSE IF (sed_abc(i).eq.'PG') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_pg=i_pg+1
            IF (i_pg.gt.mxtyp_pg) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of PEGASE templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE SEDs or modify mxtyp_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_pg(i)=i_pg
 35         READ (1,'(a)',ERR=36,END=36) line_pg 
            IF (line_pg(1:5).eq.'*****') GO TO 37
            GO TO 35
 37         READ (1,*,ERR=36,END=36) ks(i),iw(i),nemline
            IF (ks(i).gt.mxage_pg) THEN
               WRITE(*,'(a,i4)') 
     .              ' Number of ages in PEGASE templates exceeding '
     .              //'the maximum. Max = ', mxage_pg
               WRITE(*,'(a)') 
     .              'Change the SED or modify mxage_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            IF (iw(i).gt.mxwl_pg) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in PEGASE '
     .              //'templates exceeding the maximum. Max = ',mxwl_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE wavelenghts or modify mxwl_pg in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            READ(1,*) (w_pg(j,i_pg),j=1,iw(i))
            IF (w_pg(iw(i),i_pg).lt.wlmax) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,' lambda_max is ',
     .              w_pg(iw(i),i_pg),
     .              ' , lambda_max(z_max) should be ',wlmax
               WRITE(*,'(a)') 'Decrease z_max or change the template'
            END IF
            IF (w_pg(1,i_pg).gt.wlmin) THEN
               WRITE(*,'(a,i3,a,f12.2,a,f12.2)') 
     .              'Warning: Template ',i,'lambda_min is ',
     .              w_pg(1,i_pg),
     .              ' , lambda_min(z_min) should be ',wlmin
               WRITE(*,'(a)') 'Increase z_min or change the template'
            END IF
            READ(1,*) (aa8,j=1,nemline)
            DO j=1,ks(i)
c 1st line: 1.age[Myr](int), 2.Mgal[Msun], 3.Mstar[Msun], 4.MWD[Msun],
c           5.MBHNS[Msun], 6.Msub[Msun], 7.Mgas[Msun], 8.Zgas, 
c           9.<Zstars>_mass, 10.<Zstars>_Lbol
               READ(1,*) it_pg,amgal,amstar,(aa8,k=1,7)
c 2nd line: 1.L_bol[erg/s], 2. tauV, 3.Ldust/Lbol, 4.SFR[Msun/Myr],
c           5. nLymcont[s-1], 6.nSNII[Myr-1], 7.nSNIa[Myr-1], 
c           8.<age>_mass[Myr], 9.<age>_Lbol[Myr]
               READ(1,*) aa8,aa8,aa8,sfr,aa8,aa8,aa8,aa8,aa8
               READ(1,*) (ff(k),k=1,iw(i))
               t_pg(j)=DBLE(it_pg) ! it_pg is age[Myr] (integer)
               DO k=1,iw(i)
                  f_pg(k,j,i_pg)=DBLE(ff(k))
               END DO
               READ(1,*) (aa,k=1,nemline)
            END DO
c normalise in solar units
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  f_pg(ii,k,i_pg)=f_pg(ii,k,i_pg)/lsun
               END DO
            END DO
c Pegase SEDs already = 0 at lambda < 912.A
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  IF (w_pg(ii,i_pg).lt.912.) f_pg(ii,k,i_pg)=0.
               END DO
            END DO
 36         CLOSE(1)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE
            WRITE(*,*) 'Don''t know how to read :'
            WRITE(*,'(A)') filesed(i)(1:INDEX(filesed(i),' '))
            STOP
         END IF
      END DO
 2005 FORMAT(' Type ', I3, ' : ', A)
      WRITE(*,'(1x,a,i3,a)') 'Read ',i_bc,' GISSEL SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_as,' ASCII  SEDs'
      WRITE(*,'(1x,a,i3,a)') '     ',i_pg,' PEGASE SEDs'

c -----------------------------------------------------------------------
c                    Filters and header of output file
c -----------------------------------------------------------------------
      OPEN(14,FILE=spectra1,STATUS='unknown')
      CALL fdate(date)
c      CALL fdate_(date)   ! IBM
      WRITE(14,'(a)') '# Date: '//date
      WRITE(14,'(a)') 
     .     '# Templates SEDs: i, file name, format'
      DO itype=1,n_files
         last=INDEX(filesed(itype),' ')-1
         WRITE(14,'(a,1x,i3,2x,a,2x,a)') '#',itype,
     .     filesed(itype)(1:last),sed_abc(itype)
      END DO
      WRITE(14,'(a)') '# Characteristics of SED fitting filters'
      WRITE(14,'(a)') '#  n      wl_eff    surface  conv_AB'
     .     //' trans mtyp'
      WRITE(14,'(a)') '# trans: 0 energy, 1 photons'

c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
c computing AB magnitude of Vega
      DO k=1,n_filt
         vega(k)=filter(k,w_vega,f_vega,iw_vega,z0)
         DO i=1,np(k)
            xlam(i)=r(i,k,1) ! lambda
            rr2(i)=r(i,k,2)/(xlam(i)*xlam(i)) ! R/lambda^2
         END DO
         f2(k)=c*trapz1(xlam,rr2,np(k))
         conv_mag(k)=-2.5D0*DLOG10(vega(k)/f2(k))-48.60D0
         WRITE(14,1998) '#',nfil(k),wl(k),surf(k),conv_mag(k),
     .        iband(k),cmag
      END DO
 1998 FORMAT(A,1x,I4,1X,F11.3,1X,F10.3,1X,F7.3,3X,I2,3X,A5)
      IF (law_rd.eq.-1) THEN
         WRITE(14,'(a,F5.2,a,i2,a)') 
     &        '# A_V = ',av, ' ; red_law = ', law_rd, 
     &        ' ; file = '//filered(1:INDEX(filered,' '))
      ELSE
         WRITE(14,'(a,F5.2,a,i2)') 
     &        '# A_V = ',av, ' ; red_law = ', law_rd 
      END IF
      IF (iage_typ.eq.1) THEN
         WRITE(14,'(a,f5.2,a,f5.2,a,f5.3,a,f5.2)') 
     &        '# zmin = ',z_min, ', zmax = ', z_max,
     &        ', zstep =  ', dz, ', z_form = ', z_form
      ELSE
         WRITE(14,'(a,f5.2,a,f5.2,a,f5.2)') 
     &        '# zmin = ',z_min, ', zmax = ', z_max,
     &        ', zstep =  ', dz
      END IF

      DO i=1,n_filt
         IF (nfil(i).le.9) THEN
            WRITE(ch(i),'(i1)') nfil(i)
         ELSE IF (nfil(i).ge.10.and.nfil(i).le.99) THEN
            WRITE(ch(i),'(i2)') nfil(i)
         ELSE 
            WRITE(ch(i),'(i3)') nfil(i)
         END IF
         mags(i)='  m'//ch(i)
      END DO
      WRITE(fmt0,2010) n_filt
 2010 FORMAT('(A,',I3,'(A),A)')
c
      nz=INT((z_max-z_min)/dz)+1
      age_form=tz(h0,om,ov,z_form) ! age of universe at z_form
      age_uni=tz(h0,om,ov,z0)   ! age of the universe at z=0
      age_gal0=age_uni-age_form  ! age of a galaxy at z=0

      IF (sed_abc(1).eq.'A '.or.sed_abc(1).eq.'AS') THEN
         WRITE(*,'(a)') 'ASCII template, no age computed'
         WRITE(14,'(a)') '# ASCII template, no age computed'
      ELSE
         IF (iage_typ.eq.1) THEN 
            WRITE(*,'(a,f12.6,a)') 'Age of a galaxy at z = 0: Age = ',
     &           age_gal0, ' Gyr'
            WRITE(14,'(a,f10.4,a)') 
     &           '# Age of a galaxy at z = 0:     AgeGal = ',age_gal0, 
     &           ' Gyr'
         ELSE
            WRITE(*,'(a,f10.4,a)') 'Age fixed = ',age_fix, ' Gyr'
            WRITE(14,'(a,f10.4,a)')  '# Age fixed = ',age_fix, ' Gyr'
         END IF
      END IF
      WRITE(14,'(a,f10.4,a)')
     &     '# Age of the Universe at z = 0: AgeUni = ',age_uni, ' Gyr'
      WRITE(14,'(a,f10.4,a)')
     &     '# Age of the Universe at zmax:  AgeUni = ',
     &     tz(h0,om,ov,z_max), ' Gyr'
      WRITE(14,'(a,f5.2,a,f5.2,a,f5.2)') 
     &     '# Omega_0 = ',om,' ; Omega_v = ',ov,' ; H_0 = ',h0

      WRITE(14,fmt0) '#      z   iSED ',(mags(i)(1:8),i=1,n_filt), 
     &     '  D_L[Mpc]    AgeUni(z)       AgeGal       norm   '
     &     //'logMtot    logMstar    logSFR'
c -----------------------------------------------------------------
c Start computation
      DO iz=1,nz
         z=z_min+(iz-1)*dz
         age_z=tz(h0,om,ov,z)   ! age of universe at z [Gyr]
         age_galz=age_z-age_form ! age of a galaxy at z
         dl=d_l(h0,om,ov,z)     ! luminosity distance
         rnorm=dl*dl*factmass

         DO itype=1,n_files
            IF (sed_abc(itype).eq.'BC'.or.sed_abc(itype).eq.'PG') THEN
               IF(iage_typ.eq.0) THEN
                  age=age_fix
               ELSE
                  age=age_galz
               END IF
c should be improved: recomputing the SED in case of fixed age is unnecessary
               IF (sed_abc(itype).eq.'BC') THEN
                  DO k=1,ks(itype)-1
                     IF (age.ge.t_bc(k)*1.D-9.and.
     &                    age.lt.t_bc(k+1)*1.D-9) THEN
                        i1=k
                        i2=k+1
                        GO TO 48
                     END IF
                  END DO
 48               DO l=i1,i2
                     DO i=1,iw(itype) !lambda
                        f(i,l)=DBLE(f_bc(i,l,itype))
                        ww(i)=DBLE(w_bc(i,itype))
                     END DO
                  END DO
                  tx=age
                  t1=t_bc(i1)*1.D-9
                  t2=t_bc(i2)*1.D-9
                  a1=(t2-tx)/(t2-t1)
                  a2=1.-a1
c compute star mass and SFR
                  starmass=(a1*amstar(itype,i1)+
     &                 a2*amstar(itype,i2))
                  galmass=(a1*amgal(itype,i1)+
     &                 a2*amgal(itype,i2))
                  sfrgal=(a1*sfr(itype,i1)+
     &                 a2*sfr(itype,i2))
               ELSE IF (sed_abc(itype).eq.'PG') THEN
                  DO k=1,ks(itype)-1
                     IF (age.ge.t_pg(k)*1.D-3.and.
     &                    age.lt.t_pg(k+1)*1.D-3) THEN
                        i1=k
                        i2=k+1
                        GO TO 49
                     END IF
                  END DO
 49               DO l=i1,i2
                     DO i=1,iw(itype) !lambda
                        f(i,l)=DBLE(f_pg(i,l,itype))
                        ww(i)=DBLE(w_pg(i,itype))
                     END DO
                  END DO
                  tx=age
                  t1=t_pg(i1)*1.D-3
                  t2=t_pg(i2)*1.D-3
                  a1=(t2-tx)/(t2-t1)
                  a2=1.-a1
               END IF
               DO i=1,iw(itype)
                  y(i)=a1*f(i,i1)+a2*f(i,i2)
               END DO
            ELSE
               DO i=1,iw(itype)
                  y(i)=DBLE(f_as(i,1,itype))
                  ww(i)=DBLE(w_as(i,itype))
               END DO
            END IF
c Lyman forest & extinction
            DO i=1,iw(itype)
               IF (lyf.eq.1.or.lyf.eq.2) THEN
                  IF (ww(i).lt.912.0D0) y(i)=0.0D0
               END IF
            END DO
            IF (av.gt.0.0.or.law_rd.ne.0) THEN
               CALL red_spec(ww,y,av,yob,1,iw(itype),law_rd)
               DO k=1,iw(itype)
                  y(k)=yob(k)
               END DO
            END IF
            IF (lyf.eq.1) THEN
               CALL lyman_forest(ww,y,iw(itype),z)
            END IF

c compute normalisation: original one or to reproduce input magnitude 
c in selected filter
            IF (norm_filt.gt.0) THEN
               flux=filter(ifilt_n,ww,y,iw(itype),z)
               b=fl_n*f2(ifilt_n)/flux
            ELSE 
c no normalisation, keep the original one
               b=1.D0
            END IF

            DO k=1,n_filt
               flux=filter(k,ww,y,iw(itype),z)
               IF (flux.gt.1.D-100) THEN
c apparent magnitude
                  IF (mag_typ.eq.0) THEN
                     amag(k)=-2.5D0*DLOG10(b*flux/vega(k))
                  ELSE IF (mag_typ.eq.1) THEN
                     amag(k)=-2.5D0*DLOG10(b*flux/f2(k))-48.6D0
                  ELSE IF (mag_typ.eq.2) THEN
                     amag(k)=b*flux
                  END IF
               ELSE
                  amag(k)=200.D0
               END IF
            END DO
            DO k=1,n_filt
               IF (amag(k).gt.100.D0) amag(k)=99.D0
            END DO

            starmass=starmass*rnorm*b
            galmass=galmass*rnorm*b
            sfrgal=b*rnorm*sfrgal

            IF (starmass.le.1.D-20) starmass=1.D-99
            IF (galmass.le.1.D-20)  galmass=1.D-99

            IF (sed_abc(itype).eq.'BC') THEN
               WRITE(14,fmt) z,itype,(amag(k),k=1,n_filt),dl,age_z,
     &              age,b,DLOG10(galmass),DLOG10(starmass),
     &              sfrgal
            ELSE
                  starmass=10.D-99
                  galmass=10.D-99
                  sfrgal=-99
               WRITE(14,fmt) z,itype,(amag(k),k=1,n_filt),dl,age_z,
     &              age,b,DLOG10(galmass),DLOG10(starmass),
     &              sfrgal
               END IF
         END DO
      END DO
      CLOSE(14)
      last=INDEX(spectra1,'  ')-1
      WRITE(*,'(a)') 'Output written in '//spectra1(1:last)

      STOP
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening templates file'
 80   STOP 'Error reading filters'' file'
 82   STOP 'Error reading filters file'
 3    STOP 'Program exits because of error reading A0 V s.e.d. file'
      END

c............................................................
c ..... Luminosity distance [Mpc]
 
      FUNCTION d_l(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 h0,om,ov,z,za,c,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.9979D+5,nstep=100)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
c      IF (za.lt.1.D-5) THEN
c         z=1.D-5
c      ELSE
         z=za
c      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_l=c/h0*d_l ! luminosity distance in Mpc
      RETURN
      END
