c compute absolute magnitudes for the objects fitted by hyperzmass
c 25/02/2010: implemented algorithm = 0. nearest filter
c 24/05/2012: implemented computation of the "intrinsic" (dereddened) magnitude
c 25/05/2012: implemented choice for response function of filters in 
c             photons or energy (must be chosen in the main programme, 
c             not in the parameter file)
c 13/08/2012: implemented parameter for choice of response function for 
c             absolute magnitude filters (for observed ones it remains an
c             "hidden" option and can be modified by hand in the programme)
c 14/08/2012: implemented input from hyperzmass with BC templatess or 
c             hyperzspec with Bruzual & Charlot, Pegase or ASCII templates.
c             NB: new format of .out_zmass and .out_zspec files is assumed.
c             Take care of modify them accordingly (e.g. check the number of 
c             columns read about filters) if you need to run hyp_magabs 
c             on old outputs.
c 04/09/2012: changed method of reading and storing filters' transmission 
c             functions: removed convol_new, compos_new, filter0 and 
c             filter.dec, englobed in a single routine read_filt 
c     Version: 05/09/2012
      PROGRAM hyper_magabs
      IMPLICIT NONE
      INTEGER i,ii,j,k,kk,ks,n_files,kfil,iw_vega,iw,nfilt_in,nfilt_abs,
     .     iob,id,id0,law_rd,nfil,ityp,iage,last,mxage,mxage_bc,
     .     mxage_pg,mxtyp,mxtyp_bc,mxtyp_pg,mxtyp_as,mxfil,mxred,mxlyf,
     .     mxwl,mxwl_bc,mxwl_pg,mxwl_as,magtyp,magtyp_abs,iblank,input,
     .     np,mxwf,absfil,mxafil,nparam,nw,iabsfilt2,imabs,n_fil_w,
     .     magred,iband,mxrp,mxvega,iband_abs,iband_in,ierr,ihyp,
     .     ntyp_bc,ntyp_pg,ntyp_as,i_bc,i_pg,i_as,it_pg,nemline,nlyf,
     .     ifilt
      REAL*8 zs,w_vega,f_vega,t_bc,t_pg,scl,amag,err_p,avmin,avmax,
     .     averr,p,z0,y,filter,av,y0,bp1,r,time_tot,ww,h0,om,ov,
     .     c,f1,f2,trapz1,r_lyf,fact_lyf,d_l,dl,r_chi2,wl_abs,surf_abs,
     .     conv_mag,wl,surf,wl_in,surf_in,vega_abs,amabs,c_corr,age,
     .     dmod,bb,fluxz0,vega_in,snlim,agediffmin,agediff,dif_w,
     .     dif_w_min,kcorr,conv_mag_in,aa8,bp1_in,bp1_abs,amgal,amstar,
     .     sfr,lsun,fff,f_bc,f_pg,f_as,xlam,rr2
      REAL wv,fv,ff,w_bc,w_as,w_pg,t_bc0,cputime,rmag,rerr_p,aa,rzs
c
      PARAMETER (nparam=13,lsun=3.826D33)
      PARAMETER (c=2.99792458D+18) ! speed of light in AA/s
      INCLUDE 'dimensionz.dec'
      PARAMETER (mxtyp=mxtyp_bc+mxtyp_as+mxtyp_pg)

      CHARACTER sed_abc(mxtyp)*2,line*240,line_pg*80
      CHARACTER*160 filesed(mxtyp),filein,file_cat,spec_vega,
     .     filtresfile,line_sed,file_root,filered,file_out,
     .     copyright1,copyright2,cmabs*4,chyp*12,cmag*4,fmt,fmt0,fmt00,
     .     fmt2
      CHARACTER date*24,vv*5
      CHARACTER*40 cname,param(nparam)
      CHARACTER mags(mxafil)*15,mags_in(mxfil)*15,ch(mxafil)*3
c
      DIMENSION input(nparam),kfil(10),nfil(mxfil),c_corr(mxfil)
      DIMENSION ntyp_bc(mxtyp),ntyp_as(mxtyp),ntyp_pg(mxtyp)
      DIMENSION w_bc(mxwl_bc,mxtyp_bc),f_bc(mxwl_bc,mxage_bc,mxtyp_bc)
      DIMENSION w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,1,mxtyp_as)
      DIMENSION w_pg(mxwl_pg,mxtyp_pg),f_pg(mxwl_pg,mxage_pg,mxtyp_pg)
      DIMENSION iw(mxtyp),ks(mxtyp),t_bc0(mxage_bc),t_bc(mxage_bc)
      DIMENSION t_pg(mxage_pg),ff(mxwl)
      DIMENSION w_vega(mxvega),f_vega(mxvega)
      DIMENSION vega_in(mxfil),vega_abs(mxafil)
      DIMENSION iband_in(mxfil),iband_abs(mxafil)
      DIMENSION rmag(mxfil),rerr_p(mxfil)
      DIMENSION wl_in(mxfil),surf_in(mxfil),bp1_in(mxfil)
      DIMENSION wl_abs(mxafil),surf_abs(mxafil),bp1_abs(mxafil)
      DIMENSION f1(mxafil),conv_mag(mxafil),conv_mag_in(mxfil),f2(mxfil)
      DIMENSION amag(mxfil),err_p(mxfil),y0(mxwl),y(mxwl),ww(mxwl)
      DIMENSION absfil(mxafil),amabs(mxafil),n_fil_w(mxafil)
      DIMENSION xlam(mxwf),rr2(mxwf)
c
      EXTERNAL cputime,filter,pchi2,qchi2,zero,trapz1,d_l
      COMMON/compose/ifilt,np(mxfil+mxafil)
      COMMON/rfilter/r(mxwf,mxfil+mxafil,2)
      COMMON/filterres/filtresfile
      COMMON/redfile/filered
      COMMON/lyf_sigma/fact_lyf
c_________________________________________________________________________

      vv='3.2'
      copyright1='    Hyper_magabs code - Version '//vv
     .     //' (September 5th, 2012)' 
      copyright2=' by Micol Bolzonella'
      WRITE(*,*)
      WRITE(*,'(a80)') copyright1
      WRITE(*,*)
      WRITE(*,'(a80)') copyright2
      WRITE(*,*)

      iband=1         ! bandpass response function unit for observed filters: 
                      ! 0.energy; 1.photons (see e.g. Bessell 2005)
      DO i=1,mxafil
         iband_abs(i)=1 ! bandpass response function unit for Mabs filter
      END DO
      nlyf=1           ! considering only the mean Madau value
      r_lyf=1.D0
      fact_lyf=1.D0
      ihyp=0            ! input is hyperzmass output
      magtyp_abs=1      ! output absolute AB magnitudes

 11   filein='hyp_magabs.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file'
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ(*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)',ERR=11) filein
      END IF
      time_tot=DBLE(cputime())
c ------------------------------------------------------------------------
c                       Reading parameters file 
c ------------------------------------------------------------------------
c ..... Parameters' names
      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='FILE_ROOT'
      param(4)='MAG_TYPE_ABS'
      param(5)='MAG_RED'
      param(6)='FILT_MABS'
      param(7)='M_ABS_ALG'
      param(8)='SNLIM'
      param(9)='H0'
      param(10)='OMEGA_M'
      param(11)='OMEGA_V'
      param(12)='OUTPUT_FILE'
      param(13)='TRANS_ABS'

      DO i=1,nparam
         input(i)=0
      END DO

      OPEN(77,FILE=filein,STATUS='old',ERR=11)
      WRITE(*,*) 'Reading parameter file :'

 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c ..... File containing Vega spectrum
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c ..... File FILTER.RES
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... Root of the files .out_zmass and .zmass
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') file_root
         iblank=INDEX(file_root,' ')
c check whether input is .zmass or .zspec: try .zmass first
         OPEN(20,file=file_root(1:iblank-1)//'.zmass',status='old',
     &        iostat=ierr)
         CLOSE(20)
         IF (ierr.eq.0) THEN
            WRITE(*,'(a)') 'Found file '//file_root(1:iblank-1)
     &           //'.zmass'
            OPEN(21,file=file_root(1:iblank-1)//'.out_zmass',
     &           status='old',iostat=ierr)
            IF (ierr.eq.0) THEN
               ihyp=0
               chyp='hyperzmass'
            ELSE
               WRITE(*,'(a)') 'but not  '//file_root(1:iblank-1)
     &              //'.out_zmass'
               STOP
            END IF
            CLOSE(21)
         ELSE
c then try .zspec 
            OPEN(20,file=file_root(1:iblank-1)//'.zspec',status='old',
     &           iostat=ierr)
            IF (ierr.eq.0) THEN
               WRITE(*,'(a)') 'Found file '//file_root(1:iblank-1)
     &              //'.zspec'
               OPEN(21,file=file_root(1:iblank-1)//'.out_zspec',
     &              status='old',iostat=ierr)
               IF (ierr.eq.0) THEN
                  ihyp=1
                  chyp='hyperzspec'
               ELSE
                  WRITE(*,'(a)') 'but not  '//file_root(1:iblank-1)
     &                 //'.out_zspec'
                  STOP
               END IF
               CLOSE(21)
            ELSE
               WRITE(*,'(a)') 'Files '//file_root(1:iblank-1)
     &              //'.zmass'
               WRITE(*,'(a)') 'or    '//file_root(1:iblank-1)
     &              //'.zspec'
               WRITE(*,'(a)') 'not found'
               STOP
            END IF
         END IF
         input(3)=1
         GO TO 7
c ..... Magnitude type:
c       0 -> standard magnitudes
c       1 -> AB magnitudes
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,*) magtyp_abs
         IF (magtyp_abs.ne.0.and.magtyp_abs.ne.1) THEN
            WRITE(*,*) 'MAG_TYPE_ABS must be 0 or 1'
            STOP
         END IF
         IF (magtyp_abs.eq.0) THEN
            cmabs='Vega'
         ELSE IF (magtyp_abs.eq.1) THEN
            cmabs='AB'
         END IF
         input(4)=1
         GO TO 7
c ..... Reddening correction:
c       0 -> intrinsic dereddened absolute magnitudes (use with caution)
c            (i.e. considering the best fit template with A_V=0)
c       1 -> absolute magnitudes from best fit template (usual method)
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) magred
         IF (magred.ne.0.and.magred.ne.1) THEN
            WRITE(*,*) 'MAG_RED must be 0 or 1'
            STOP
         END IF
         input(5)=1
         GO TO 7
c ..... Filter for the absolute magnitudes (as in FILTERS_RES file)
      ELSE IF (cname.eq.param(6)) THEN
c read filters for abs mag (max mxafil)
         nfilt_abs=1
         DO k=1,160
            IF (line(k:k).eq.',') THEN
               line(k:k)=' '
               nfilt_abs=nfilt_abs+1
            END IF
            IF (line(k:k).eq.'#') THEN ! end of filters' list
               line=line(1:k-1)
               GO TO 999
            END IF
         END DO
 999     READ(line,*) (absfil(k),k=1,nfilt_abs)
         input(6)=1
         WRITE(fmt,2012) nfilt_abs
         WRITE(fmt2,2013) nfilt_abs,nfilt_abs
 2012    FORMAT('(1X,I12,2X,F9.5,2X,I4,2X,F8.4,1X,F5.2,1X,ES10.4,',
     &        i2,'(1X,F8.4),1X,F11.3)')
 2013    FORMAT('(1X,I12,2X,F9.5,2X,I4,2X,F8.4,1X,F5.2,1X,ES10.4,',
     &        i2,'(1X,F8.4),',i2,'(1X,I5),1X,F11.3)')
         GO TO 7
c ..... Algorithm to compute absolute magnitudes: 
c       0. nearest filter 1. best fit normalization
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) imabs 
         IF (imabs.ne.0.and.imabs.ne.1) THEN
            WRITE(*,*) 'MAG_ABS_ALG must be 0 or 1'
            STOP
         END IF
         input(7)=1
         GO TO 7
c ..... S/N limit for a reference filter if MAG_ABS_ALG=0
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) snlim
         input(8)=1
         GO TO 7
c ..... Cosmological parameters to compute the universe age and M_abs 
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) h0
         input(9)=1
         GO TO 7
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) om
         input(10)=1
         GO TO 7
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) ov
         input(11)=1
         GO TO 7
c ..... Output file
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,'(A)') file_out
         input(12)=1
         GO TO 7
c ..... Filter for the absolute magnitudes (as in FILTERS_RES file)
      ELSE IF (cname.eq.param(13)) THEN
c ..... Transmission of absolute magnitude filter (max mxafil): 
c       0. energy 1. photons
         iabsfilt2=1
         DO k=1,160
            IF (line(k:k).eq.',') THEN
               line(k:k)=' '
               iabsfilt2=iabsfilt2+1
            END IF
            IF (line(k:k).eq.'#') THEN ! end of filters' list
               line=line(1:k-1)
               GO TO 888
            END IF
         END DO
 888     READ(line,*) (iband_abs(k),k=1,iabsfilt2)
         input(13)=1
         GO TO 7
      ELSE 
         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)
c check number of filters and number of type of transmission functions:
      IF (nfilt_abs.ne.iabsfilt2.and.iabsfilt2.ne.1) THEN
         WRITE(*,'(a,i3,a,i3,a)') 'Number of TRANS_ABS (=',iabsfilt2,
     &        ') is different from FILT_MABS (=',nfilt_abs,')'
         STOP
c only one type of transmission function to be applied to all filters
      ELSE IF (iabsfilt2.eq.1.and.nfilt_abs.gt.1) THEN
         DO k=2,nfilt_abs
            iband_abs(k)=iband_abs(1)
         END DO
      END IF
c ..... Vega
      WRITE (*,'(1x,a)') 'Vega SED:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(a)') line (1:80)
c      scl=2.D-17
      scl=1.D0
      z0=0.D0
      i=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(i)=DBLE(wv)
      f_vega(i)=DBLE(fv)*scl
      i=i+1
      GO TO 223
 222  iw_vega=i-1
      CLOSE(10)
      WRITE(*,'(a,1x,i6,1x,a)') 'There are ',iw_vega,' points in Vega'

c -----------------------------------------------------------------------
c              Reading file .out_zmass and writing output header
c -----------------------------------------------------------------------
c write info in output file
      OPEN(13,FILE=file_out,STATUS='unknown')
      CALL fdate(date)
      WRITE(13,'(a)') '# Date: '//date
      WRITE(13,'(a)') '# Input '//chyp//' file: '
     &     //file_root(1:INDEX(file_root,' '))
      WRITE(13,'(a)') '# Input SEDs:'
c
      last=INDEX(file_root,' ')-1
      IF (ihyp.eq.0) THEN
         WRITE(*,'(a)') 'Reading file '//file_root(1:last)//'.out_zmass'
         OPEN(11,FILE=file_root(1:last)//'.out_zmass',STATUS='old',
     &        ERR=78)
      ELSE
         WRITE(*,'(a)') 'Reading file '//file_root(1:last)//'.out_zspec'
         OPEN(11,FILE=file_root(1:last)//'.out_zspec',STATUS='old',
     &        ERR=78)
      END IF
      READ(11,'(a)') line
      READ(11,'(a)') line
      READ(11,'(a)') file_cat
      READ(11,'(a)') line
      i=1
      DO WHILE (file_cat(i:i).eq.' ') 
         i=i+1
      END DO
      file_cat=file_cat(i:)
c check whether photometric catalogue exists
      OPEN(20,file=file_cat,status='old',iostat=ierr)
      CLOSE(20)
      IF (ierr.gt.0) THEN
         WRITE(*,'(a)') 'Catalogue file not found:'
         WRITE(*,'(a)') file_cat(1:80)
         STOP
      END IF
c Read names of template SEDs
 15   READ(11,'(a)',ERR=12,END=12) line
      IF (line(1:1).eq.'#') THEN
         GO TO 12
      ELSE
         READ (line,*) ityp
         IF (ityp.eq.1) ii=INDEX(line,'1')+1
         line_sed=line(ii:)
         i=1
         DO WHILE (line_sed(i:i).eq.' ')
            i=i+1
         END DO
         line_sed=line_sed(i:)
         last=INDEX(line_sed,' ')-1
         filesed(ityp)=line_sed(1:last)
         line_sed=line_sed(last+1:)
         i=1
         DO WHILE (line_sed(i:i).eq.' ')
            i=i+1
         END DO
         sed_abc(ityp)=line_sed(i:i+1)
         WRITE(13,'(a,i3,2x,a,a)') '# ',ityp,
     &        filesed(ityp)(1:INDEX(filesed(ityp),' ')),
     &        sed_abc(ityp)
         IF (sed_abc(ityp).ne.'BC'.and.sed_abc(ityp).ne.'PG'.and.
     &        sed_abc(ityp).ne.'AS'.and.sed_abc(ityp).ne.'A ') THEN
            WRITE(*,'(a,i3,a)') 'Type for SED ',ityp,' is unknown: '
     &           //sed_abc(ityp)
            STOP
         END IF
         GO TO 15
      END IF
 12   n_files=ityp
      WRITE(*,'(a,1x,i4,1x,a)') 'There are ',n_files,
     &     ' synthetic spectra'
c Read number of input filters in photometric catalogue
      ifilt=0
 13   READ(11,'(a)',ERR=14,END=14) line
      IF (line(1:1).eq.'#') THEN
         IF (ifilt.eq.0) GO TO 13
         GO TO 14
      ELSE
         ifilt=ifilt+1
         READ (line,*) nfil(ifilt),aa,aa,aa,aa,c_corr(ifilt),aa,ii,
     &        iband_in(ifilt),aa,ii,cmag
         IF (cmag.eq.'AB') THEN
            magtyp=1
         ELSE IF (cmag.eq.'Vega') THEN
            magtyp=0
         ELSE IF (cmag.eq.'muJy') THEN
            magtyp=2
         END IF
         kfil(1)=nfil(ifilt)
c read_filt subroutine replace compos_filt and filter0
         CALL read_filt(1,kfil,wl,surf,bp1,iband_in(ifilt))
         wl_in(ifilt)=wl
         surf_in(ifilt)=surf
         bp1_in(ifilt)=bp1
         GO TO 13
      END IF
 14   nfilt_in=ifilt ! number of observed filters

      DO k=1,nfilt_in
         vega_in(k)=filter(k,w_vega,f_vega,iw_vega,z0)
         DO i=1,np(k)
            xlam(i)=r(i,k,1) ! lambda
            rr2(i)=r(i,k,2)/(xlam(i)*xlam(i)) ! R/lambda^2
         END DO
         f2(k)=c*trapz1(xlam,rr2,np(k))
         conv_mag_in(k)=-2.5D0*DLOG10(vega_in(k)/f2(k))-48.60D0
      END DO
c absolute magnitude filters
      DO k=1,nfilt_abs
c ..... assume simple filter
         ifilt=ifilt+1
         kfil(1)=absfil(k)
         CALL read_filt(1,kfil,wl,surf,bp1,iband_abs(k))
         wl_abs(k)=wl
         surf_abs(k)=surf
         bp1_abs(k)=bp1
      END DO
c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
      WRITE(*,'(a)') '#  Absolute magnitude filters'
      WRITE(*,'(a)') '#  n     wl_eff     surface   conv_AB'
      DO k=1,nfilt_abs
         kk=k+nfilt_in
         vega_abs(k)=filter(kk,w_vega,f_vega,iw_vega,z0)
c integrals with trapezoids
         DO i=1,np(kk)
            xlam(i)=r(i,kk,1) ! lambda
            rr2(i)=r(i,kk,2)/(xlam(i)*xlam(i)) ! R/lambda^2
         END DO
         f1(k)=c*trapz1(xlam,rr2,np(kk))
         conv_mag(k)=-2.5D0*DLOG10(vega_abs(k)/f1(k))-48.60D0
         WRITE(*,'(i4,2x,f10.2,2x,f9.2,2x,f8.4,2x,i4)') 
     &        absfil(k),wl_abs(k),surf_abs(k),conv_mag(k),iband_abs(k)
      END DO
c continue reading .out_zmass/.out_zspec file
      READ(11,'(a)') line
      READ(line,*) avmin,avmax,averr,law_rd
      IF (law_rd.eq.-1) THEN 
c read also file of user provided reddening law
         READ(line,*) avmin,avmax,averr,law_rd,filered
      END IF
      READ(11,'(a)') line
      READ(11,*) r_lyf
      CLOSE(11)
c write info on output file
      WRITE(13,'(a,i2,a,i2,a,f4.1)') 
     &     '# Input mag type '//cmag//' ; Mabs type '//cmabs//
     &     ' ; Mabs reddening =',magred,
     &     ' ; Mabs algorithm =',imabs,' ; SNlim = ',snlim
      WRITE(13,'(a,f4.2,a,f4.2,a,f5.1)') 
     &     '# Cosmology: Om = ',om,' ; Ov = ',ov,' ; H0 = ',h0
      WRITE(13,'(a)') '# Input apparent magnitudes in catalogue '//
     &     file_cat(1:INDEX(file_cat,' '))//':'
      WRITE(13,'(a)') '# (Number of filter in '//
     &     filtresfile(1:INDEX(filtresfile,' '))//')'
      WRITE(13,'(a)') '#  Filter  lambda     surface    offset '
     &     //'  conv_AB   trans'
      DO k=1,nfilt_in
         WRITE(13,'(a,i4,2x,f10.2,2x,f9.2,2x,f8.4,2x,f8.4,'
     &        //'2x,i3)') '# ',nfil(k),wl_in(k),surf_in(k),
     &        c_corr(k),conv_mag_in(k),iband_in(k)
      END DO
      WRITE(13,'(a)') '# Output absolute magnitudes '
      WRITE(13,'(a)') '#  Filter  lambda     surface   conv_AB   '
     &     //'trans'
      DO k=1,nfilt_abs
         WRITE(13,'(a,i4,2x,f10.2,2x,f9.2,2x,f8.4,2x,i3)') '# ',
     &        absfil(k),wl_abs(k),surf_abs(k),conv_mag(k),iband_abs(k)
      END DO
c -----------------------------------------------------------------------
c                       Reading synthetic spectra 
c -----------------------------------------------------------------------
c ..... SED
      WRITE(*,*) 'Reading synthetic spectra :'
      i_bc=0
      i_as=0
      i_pg=0
      DO i=1,n_files
         ntyp_bc(i)=-1
         ntyp_as(i)=-1
         ntyp_pg(i)=-1
      END DO 
      DO i=1,n_files
         last=INDEX(filesed(i),' ')
         WRITE(*,2005) i,filesed(i)(1:last)
c Bruzual&Charlot templates
         IF (sed_abc(i).eq.'BC') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',FORM='unformatted',
     .           ERR=25)
            i_bc=i_bc+1
            IF (i_bc.gt.mxtyp_bc) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of GISSEL templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_bc
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL SEDs or modify mxtyp_bc in '
     .              //'dimensionz.dec and recompile'
               STOP
            END IF
            ntyp_bc(i)=i_bc
c ks = n of temporal intervals, t_bc and t_bc0 in [yr]
            READ (1) ks(i),(t_bc0(ii),ii=1,ks(i))
c iw = number of wavelengths, w_bc wavelength in [A]
            READ (1) iw(i),(w_bc(ii,i),ii=1,iw(i)) 
            IF (iw(i).gt.mxwl) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in GISSEL '
     .              //'templates exceeding the maximum. Max = ',mxwl
               WRITE(*,'(a)') 
     .              ' Reduce GISSEL wavelenghts or modify mxwl in '
     .              //'dimensionmass.dec and recompile'
               STOP
            END IF
            DO k=1,ks(i)
               t_bc(k)=DBLE(t_bc0(k))
               READ (1) iw(i),(ff(ii),ii=1,iw(i))
               DO ii=1,iw(i)
                  IF (w_bc(ii,i_bc).lt.912.) THEN
                     f_bc(ii,k,i_bc)=0.D0
                  ELSE
                     f_bc(ii,k,i_bc)=DBLE(ff(ii))
                  END IF
               END DO
            END DO
            CLOSE(1)
c ASCII templates
         ELSE IF (sed_abc(i).eq.'AS'.or.sed_abc(i).eq.'A ') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',FORM='formatted',ERR=25)
            i_as=i_as+1
            IF (i_as.gt.mxtyp_as) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of ASCII templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII SEDs or modify mxtyp_as in '
     .              //'dimensionspec.dec and recompile'
               STOP
            END IF
            ntyp_as(i)=i_as
            ks(i)=1
            ii=1
 33         READ(1,'(A)',ERR=34,END=34) line_sed
            IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 33
            READ(line_sed,*) w_as(ii,i_as),fff
            f_as(ii,1,i_as)=fff
            ii=ii+1
            IF (ii.gt.mxwl_as) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in ASCII '
     .              //'templates exceeding the maximum. Max = ',mxwl_as
               WRITE(*,'(a)') 
     .              ' Reduce ASCII wavelenghts or modify mxwl_as in '
     .              //'dimensionspec.dec and recompile'
               STOP
            END IF
            GO TO 33
 34         iw(i)=ii-1
            CLOSE(1)
c PEGASE templates
         ELSE IF (sed_abc(i).eq.'PG') THEN
            OPEN(1,FILE=filesed(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            i_pg=i_pg+1
            IF (i_pg.gt.mxtyp_pg) THEN
               WRITE(*,'(a,i3)') 
     .              ' Number of PEGASE templates exceeding the maximum.' 
     .              //' Max = ',mxtyp_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE SEDs or modify mxtyp_pg in '
     .              //'dimensionspec.dec and recompile'
               STOP
            END IF
            ntyp_pg(i)=i_pg
 35         READ (1,'(a)',ERR=36,END=36) line_pg 
            IF (line_pg(1:5).eq.'*****') GO TO 37
            GO TO 35
 37         READ (1,*,ERR=36,END=36) ks(i),iw(i),nemline
            IF (ks(i).gt.mxage_pg) THEN
               WRITE(*,'(a,i4)') 
     .              ' Number of ages in PEGASE templates exceeding '
     .              //'the maximum. Max = ', mxage_pg
               WRITE(*,'(a)') 
     .              ' Change the SED or modify mxage_pg in '
     .              //'dimensionspec.dec and recompile'
               STOP
            END IF
            IF (iw(i).gt.mxwl_pg) THEN
               WRITE(*,'(a,i6)') 'Number of wavelengths in PEGASE '
     .              //'templates exceeding the maximum. Max = ',mxwl_pg
               WRITE(*,'(a)') 
     .              ' Reduce PEGASE wavelenghts or modify mxwl_pg in '
     .              //'dimensionspec.dec and recompile'
               STOP
            END IF
            READ(1,*) (w_pg(j,i_pg),j=1,iw(i))
            READ(1,*) (aa8,j=1,nemline)
            DO j=1,ks(i)
c 1st line: 1.age[Myr](int), 2.Mgal[Msun], 3.Mstar[Msun], 4.MWD[Msun],
c           5.MBHNS[Msun], 6.Msub[Msun], 7.Mgas[Msun], 8.Zgas, 
c           9.<Zstars>_mass, 10.<Zstars>_Lbol
               READ(1,*) it_pg,amgal,amstar,(aa8,k=1,7)
c 2nd line: 1.L_bol[erg/s], 2. tauV, 3.Ldust/Lbol, 4.SFR[Msun/Myr],
c           5. nLymcont[s-1], 6.nSNII[Myr-1], 7.nSNIa[Myr-1], 
c           8.<age>_mass[Myr], 9.<age>_Lbol[Myr]
               READ(1,*) aa8,aa8,aa8,sfr,aa8,aa8,aa8,aa8,aa8
               READ(1,*) (ff(k),k=1,iw(i))
               t_pg(j)=DBLE(it_pg) ! it_pg is age[Myr] (integer)
               DO k=1,iw(i)
                  f_pg(k,j,i_pg)=DBLE(ff(k))
               END DO
               READ(1,*) (aa,k=1,nemline)
            END DO
c normalise in solar units
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  f_pg(ii,k,i_pg)=f_pg(ii,k,i_pg)/lsun
               END DO
            END DO
c Pegase SEDs already = 0 at lambda < 912.A
            DO k=1,ks(i)
               DO ii=1,iw(i)
                  IF (w_pg(ii,i_pg).lt.912.) f_pg(ii,k,i_pg)=0.D0
               END DO
            END DO
 36         CLOSE(1)
         ELSE
            WRITE(*,*) 'Format unknown for file :'
            WRITE(*,'(A)') filesed(i)(1:INDEX(filesed(i),' '))
            STOP
         END IF
      END DO
 2005 FORMAT(' Type ', I2, ' : ', A)
c -----------------------------------------------------------------------
c                          Loop over the objects 
c -----------------------------------------------------------------------

      DO i=1,nfilt_abs
         IF (absfil(i).le.9) THEN
            WRITE(ch(i),'(i1)') absfil(i)
         ELSE IF (absfil(i).ge.10.and.absfil(i).le.99) THEN
            WRITE(ch(i),'(i2)') absfil(i)
         ELSE 
            WRITE(ch(i),'(i3)') absfil(i)
         END IF
         mags_in(i)='f_in'//ch(i)
         IF (magtyp_abs.eq.0.or.magtyp_abs.eq.1) THEN
            mags(i)='  Mabs'//ch(i)
         ELSE IF (magtyp_abs.eq.2) THEN
            mags(i)='  Flux'//ch(i)
         END IF         
      END DO
      WRITE(fmt0,2010) nfilt_abs
      WRITE(fmt00,2010) 2*nfilt_abs
 2010 FORMAT('(A,',I3,'(A))')
      IF (imabs.eq.1) THEN
         WRITE(13,fmt0) '#     ID           z_s    iSED       age'
     &        //'   A_V      norm ',(mags(i)(1:9),i=1,nfilt_abs)
      ELSE
         WRITE(13,fmt00) '#     ID           z_s    iSED       age'
     &        //'   A_V      norm ',(mags(i)(1:9),i=1,nfilt_abs),
     &        (mags_in(i)(1:INDEX(mags_in(i),' ')),i=1,nfilt_abs)
      END IF
c open photometric catalogue and .zmass file and skip the headers
      OPEN(16,FILE=file_cat,STATUS='old',ERR=79)
 44   READ(16,'(a)') line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 44
      BACKSPACE(16)

      last=INDEX(file_root,' ')-1
      IF (ihyp.eq.0) THEN
         WRITE(*,'(a)') 'Reading file '//file_root(1:last)//'.zmass'
         OPEN(15,FILE=file_root(1:last)//'.zmass',STATUS='old',
     &        ERR=78)
      ELSE
         WRITE(*,'(a)') 'Reading file '//file_root(1:last)//'.zspec'
         OPEN(15,FILE=file_root(1:last)//'.zspec',STATUS='old',
     &        ERR=78)
      END IF
 45   READ(15,'(a)') line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 45
      BACKSPACE(15)

      iob=0
13400 CONTINUE
      iob=iob+1
      READ(16,*,ERR=13500,END=13500) id,(rmag(k),k=1,nfilt_in),
     .     (rerr_p(k),k=1,nfilt_in)
c read only the first fields (common to .zmass and .zspec files)
      READ(15,*) id0,rzs,r_chi2,p,ityp,iage,age,av,bb
      IF (id.ne.id0) THEN
         WRITE(*,'(a,1x,i12,1x,i12)') 
     &        'The IDs are not in the same order in the catalogue'
     &        //' and in the file from '//chyp,id,id0 
         STOP
      END IF
      zs=DBLE(rzs)
      dl=d_l(h0,om,ov,zs)
      IF (ityp.lt.1) THEN ! no best fit is present in zmass file
         DO k=1,nfilt_abs
            amabs(k)=-99.D0
         END DO
         ii=-99
         IF (imabs.eq.0) THEN
            WRITE(13,fmt2) id,zs,ityp,age,av,bb,
     &           (amabs(k),k=1,nfilt_abs),(ii,k=1,nfilt_abs),dl
         ELSE if (imabs.eq.1) THEN
            WRITE(13,fmt) id,zs,ityp,age,av,bb,
     &           (amabs(k),k=1,nfilt_abs),dl
         END IF
         GO TO 13400
      END IF
c determine the type of best fit SED
      IF (sed_abc(ityp).eq.'BC') THEN
c recompute iage, to be consistent also with masses with age rebin
         agediffmin=1.D10
         DO k=1,ks(ityp)
            agediff=ABS(age-t_bc(k)*1.D-9)
            IF (agediff.lt.agediffmin) THEN
               iage=k
               agediffmin=agediff
            END IF
         END DO
      ELSE IF (sed_abc(ityp).eq.'PG') THEN
c recompute iage, to be consistent also with masses with age rebin
         agediffmin=1.D10
         DO k=1,ks(ityp)
            agediff=ABS(age-t_pg(k)*1.D-3)
            IF (agediff.lt.agediffmin) THEN
               iage=k
               agediffmin=agediff
            END IF
         END DO
      END IF

      DO k=1,nfilt_in
         amag(k)=DBLE(rmag(k)+c_corr(k))
         err_p(k)=DBLE(rerr_p(k))
      END DO
      dl=d_l(h0,om,ov,zs)   !luminosity distance in Mpc
      IF (dl.gt.0.D0) dmod=5.D0*DLOG10(dl)+25.D0
c minimum dmod: corresponding to d(~M31)=1000 Kpc
      IF (dmod.lt.25.D0) dmod=25.D0 
      nw=iw(ityp)
      DO i=1,nw
         IF (sed_abc(ityp).eq.'BC') THEN
            y0(i)=f_bc(i,iage,ntyp_bc(ityp))
            ww(i)=DBLE(w_bc(i,ntyp_bc(ityp)))
         ELSE IF (sed_abc(ityp).eq.'PG') THEN
            y0(i)=f_pg(i,iage,ntyp_pg(ityp))
            ww(i)=DBLE(w_pg(i,ntyp_pg(ityp)))
         ELSE IF (sed_abc(ityp).eq.'AS'.or.sed_abc(ityp).eq.'A ') THEN
            y0(i)=f_as(i,iage,ntyp_as(ityp))
            ww(i)=DBLE(w_as(i,ntyp_as(ityp)))
         END IF
         y(i)=y0(i)
      END DO
c apply best fit reddening to best fit template
      IF (av.gt.0..and.law_rd.ne.0) THEN
         CALL red_spec(ww,y0,av,y,1,nw,law_rd)
      END IF
      CALL lyman_forest(ww,y,nw,zs)
      CALL lyman_forest(ww,y0,nw,zs)
c Absolute magnitude:
c 0. use the nearest observed filter to minimize k-correction
c 1. compute directly from the SED best fit 
      DO k=1,nfilt_abs   
         kk=nfilt_in+k
         IF (imabs.eq.0) THEN      ! use the nearest rest frame filter 
c search for nearest filter at zs 
            n_fil_w(k)=0
            dif_w_min=1.D12
            DO i=1,nfilt_in
               dif_w=ABS(wl_in(i)-wl_abs(k)*(zs+1.D0))
               IF (amag(i).gt.1.D0.and.amag(i).lt.90.D0
     .              .and.(2.5/LOG(10.))/err_p(i).ge.snlim) THEN
                  IF (dif_w.lt.dif_w_min) THEN   
                     dif_w_min=dif_w 
                     n_fil_w(k)=i
                  END IF
               END IF
            END DO
c if no filters within S/N constraint -> use best fit sed normalization
            IF (magred.eq.0) THEN
               fluxz0=filter(kk,ww,y0,nw,z0)
            ELSE
               fluxz0=filter(kk,ww,y,nw,z0)
            END IF
            IF (n_fil_w(k).eq.0) THEN
               IF (magtyp_abs.eq.1) THEN ! output AB mag
                  amabs(k)=-2.5D0*DLOG10(bb*fluxz0/f1(k))-dmod-48.6
               ELSE IF (magtyp_abs.eq.0) THEN ! output Vega mag
                  amabs(k)=-2.5D0*DLOG10(bb*fluxz0/vega_abs(k))-dmod
               END IF
            ELSE ! really use nearest filter
               IF (magtyp_abs.eq.0) THEN ! output Vega mag
                  kcorr=2.5D0*DLOG10((fluxz0/vega_abs(k))*
     .                 (vega_in(n_fil_w(k))/
     .                 filter(n_fil_w(k),ww,y,nw,zs)))
                  IF (magtyp.eq.0) THEN ! input Vega mag
                     amabs(k)=amag(n_fil_w(k))-dmod-kcorr
                  ELSE IF (magtyp.eq.1) THEN ! input AB mag
                     amabs(k)=amag(n_fil_w(k))-conv_mag_in(n_fil_w(k))
     .                    -dmod-kcorr
                  ELSE IF (magtyp.eq.2) THEN ! input muJy
                     amabs(k)=-2.5D0*DLOG10(amag(n_fil_w(k))*1.E-29)
     .                    -48.6-conv_mag_in(n_fil_w(k))-dmod-kcorr
                  END IF
               ELSE IF (magtyp_abs.eq.1) THEN ! output AB mag
                  kcorr=2.5D0*DLOG10((fluxz0/f1(k))*(f2(n_fil_w(k))/
     .                 filter(n_fil_w(k),ww,y,nw,zs)))
                  IF (magtyp.eq.0) THEN ! input Vega mag
                     amabs(k)=amag(n_fil_w(k))+conv_mag_in(n_fil_w(k))
     .                    -dmod-kcorr
                  ELSE IF (magtyp.eq.1) THEN ! input AB mag
                     amabs(k)=amag(n_fil_w(k))-dmod-kcorr
                  ELSE IF (magtyp.eq.2) THEN ! input muJy
                     amabs(k)=-2.5D0*DLOG10(amag(n_fil_w(k))*1.E-29)
     .                    -48.6-dmod-kcorr
                  END IF
               END IF
            END IF
         ELSE IF (imabs.eq.1) THEN ! use the best fit normalization
            IF (magred.eq.0) THEN
               fluxz0=filter(kk,ww,y0,nw,z0)
            ELSE
               fluxz0=filter(kk,ww,y,nw,z0)
            END IF
            IF (magtyp_abs.eq.1) THEN ! output AB mag
               amabs(k)=-2.5D0*DLOG10(bb*fluxz0/f1(k))-dmod-48.6
            ELSE IF (magtyp_abs.eq.0) THEN ! output Vega mag
               amabs(k)=-2.5D0*DLOG10(bb*fluxz0/vega_abs(k))-dmod
            END IF
         END IF
      END DO
      IF (imabs.eq.0) THEN
         WRITE(13,fmt2) id,zs,ityp,age,av,bb,(amabs(k),k=1,nfilt_abs),
     &        (nfil(n_fil_w(k)),k=1,nfilt_abs),dl
      ELSE if (imabs.eq.1) THEN
         WRITE(13,fmt) id,zs,ityp,age,av,bb,(amabs(k),k=1,nfilt_abs),
     &        dl
      END IF
c.......................................................................
      GO TO 13400
13500 CONTINUE
c.......................................................................
      write(*,*) 'Nobj = ',iob-1
      CLOSE(16)
      CLOSE(15)
      CLOSE(13)

      time_tot=DBLE(cputime())-time_tot
      WRITE(*,'(a)') ' Done !!!'
      WRITE(*,'(1X,A,F12.3,A)') 'Total CPU time involved : ', time_tot, 
     .     ' seconds'
      STOP
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening .zmass/.zspec or .out_zmass/.out_zspec file'
 79   STOP 'Error opening catalogue file'
 80   STOP 'Error opening filters file'
 81   STOP 'Error opening output files'
 82   STOP 'Error reading filters file'
      END
c----------------------------------------------------------------------
c ..... Luminosity distance [Mpc]
 
      FUNCTION d_l(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 h0,om,ov,z,za,c,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.99792458D+5,nstep=1000)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
      IF (za.lt.1.D-5) THEN
         z=1.D-5
      ELSE
         z=za
      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_l=c/h0*d_l ! luminosity distance in Mpc
      RETURN
      END
c ----------------------------------------------------------------------
