c *******************************************************************
c  This program selects the best chi2 solution among different runs of 
c  hyperzmass: 
c *******************************************************************
      PROGRAM hyperz_classify
c     Version: 02/09/2009
      IMPLICIT NONE
      INTEGER i,j,k,k0,nparam,input,iblank,nobj,nobj1,last,id,id1,
     &     nmx,nfiles,ii,lastz,nmxobj,iunit
      PARAMETER (nparam=2,nmxobj=1000000,nmx=10)
      REAL*8 aa,chi2(nmx),chi2min
      CHARACTER*5000 linez,filein,fileshyp,fileout,line,filehyp(nmx),
     &     lineout
      CHARACTER*40 cname,param(nparam),cc*1
      DIMENSION input(nparam),id(nmxobj),id1(nmxobj),lastz(nmx)
c ------------------------------------------------------------------------
 11   filein='hyperz_bestX2.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file'
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ(*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)',ERR=11) filein
      END IF
c ------------------------------------------------------------------------
c                       Reading parameters file 
c ------------------------------------------------------------------------

      param(1)='HYPER_FILES'
      param(2)='OUTPUT_FILE'

      DO i=1,nparam
         input(i)=0
      END DO
      OPEN(77,FILE=filein,STATUS='old',ERR=11)
      WRITE(*,'(A)') ' Reading parameter file...'

 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,160
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c ..... Hyper files
      IF (cname.eq.param(1)) THEN
c read name of files to be compared (max 10)
         nfiles=0
         k0=1
         DO k=1,5000
            IF (line(k:k).eq.',') THEN
               nfiles=nfiles+1
               filehyp(nfiles)=line(k0:k-1)
               k0=k+1
            ELSE IF (line(k:k).eq.' ') THEN ! last file
               nfiles=nfiles+1
               filehyp(nfiles)=line(k0:k-1)
               GO TO 999
            ELSE IF (line(k:k).eq.'#') THEN ! end of list
               GO TO 999
            END IF
         END DO
 999     IF (nfiles.eq.1) THEN
            WRITE(*,'(a)') 'Read only one file name, nothing to compare'
            STOP
         ELSE
            WRITE(*,'(a,i3)') 'Number of files to be compared: ',nfiles 
            DO k=1,nfiles
               last=INDEX(filehyp(k),'  ')-1
               WRITE(*,'(i3,a)') k,' '//
     &              filehyp(k)(1:last)
            END DO
         END IF
         input(1)=1
         GO TO 7
c ..... Output file
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') fileout
         input(2)=1
         GO TO 7
      ELSE 
         WRITE(*,'(A,1x,A)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)
      DO i=1,nparam
         IF (input(i).eq.0) THEN
            WRITE(*,*) 'Missed parameter ', param(i)
            STOP
         END IF
      END DO
c ..... count objects in the input files
      WRITE(*,'(A)') ' Reading files to compare the number of objects' 
      OPEN(10,FILE=filehyp(1),STATUS='old')
      j=1
      lastz(1)=0
 50   READ(10,'(a)',ERR=51,END=51) linez
      IF (linez(1:1).eq.'#'.or.linez.eq.' ') GO TO 50
      READ(linez,*) id(j)
      IF(lastz(1).eq.0) 
     &     lastz(1)=INDEX(linez,'                            ')
      j=j+1
      GO TO 50
 51   nobj=j-1
      CLOSE(10)
      i=1
      WRITE(*,'(a,i3,a,i9)') 'Number of objects in file ',i,
     &     ' is ',nobj
c     
      DO i=2,nfiles
         lastz(i)=0
         OPEN(11,FILE=filehyp(i),STATUS='old')
         j=1
 60      READ(11,'(a)',ERR=61,END=61) linez
         IF (linez(1:1).eq.'#'.or.linez.eq.' ') GO TO 60
         READ(linez,*) id1(j)
         IF(lastz(i).eq.0) 
     &        lastz(i)=INDEX(linez,'                            ')
         IF (id1(j).ne.id(j)) THEN
            last=INDEX(filehyp(i),'  ')-1
            WRITE(*,'(a)') 'Error reading file '//
     &           filehyp(i)(:last) 
            WRITE(*,'(a,3(1x,i10))') 'Object IDs not in the same order',
     &           id(j),id1(j),j
            STOP
         END IF
         j=j+1
         GO TO 60
 61      nobj1=j-1
         CLOSE(11)
         WRITE(*,'(a,i3,a,i9)') 'Number of objects in file ',i,
     &        ' is ',nobj1
         IF (nobj1.ne.nobj) THEN
            STOP 'Number of objects is different'
         END IF
      END DO
c now read the data
      WRITE(*,'(a)') 'Start comparison of chi2'
      DO i=1,nfiles
         iunit=10+i
         OPEN(iunit,file=filehyp(i),STATUS='old')
      END DO
      OPEN(88,file=fileout,status='new')
      DO i=1,nfiles
         last=INDEX(filehyp(i),'  ')-1
         WRITE(88,'(a,i3,a)') '# ',i,' '//
     &        filehyp(i)(:last)
      END DO
c
      DO j=1,nobj
         i=1
         iunit=10+i
 70      READ(iunit,'(a)') linez
         IF (linez(1:1).eq.'#'.or.linez.eq.' ') GO TO 70
         READ(linez,*) ii,aa,chi2(i)
         chi2min=chi2(i)
         lineout=linez(:lastz(i))//char(48+i)
         DO i=2,nfiles
            iunit=10+i
 80         READ(iunit,'(a)') linez
            IF (linez(1:1).eq.'#'.or.linez.eq.' ') GO TO 80
            READ(linez,*) ii,aa,chi2(i)
            IF (chi2(i).lt.chi2min) THEN
               lineout=linez(:lastz(i))//char(48+i)
               chi2min=chi2(i)
            END IF
         END DO
         WRITE(88,'(a)') lineout(:INDEX(lineout,'                    '))
      END DO
      CLOSE(88)
      DO i=1,nfiles
         iunit=10+i
         CLOSE(iunit)
      END DO
      WRITE(*,'(a)') 'Done'
      last=INDEX(fileout,'  ')-1
      WRITE(*,'(a)') 'See results in '//fileout(1:last)
c
      STOP
      END
