      FUNCTION pchi2_old(a,x)
      IMPLICIT NONE
      INTEGER i, iteven, ndeg
      REAL*8 pchi2_old, a, x, gamma, prod, err, rest, f, c, aa
      PARAMETER (err=5.D-7)
      EXTERNAL gamma

      IF (x.lt.0.D0.or.a.le.0.D0) STOP 
     .     'Bad input for incomplete gamma function P'
      ndeg=INT(a*2.D0)
      rest=DMOD(a*2.D0,2.D0)
      
      IF (rest.lt.0.001D0) THEN ! even degrees of freedom
         iteven=ndeg/2
         pchi2_old=0.D0
         prod=1.D0
         DO i=1,iteven
            pchi2_old=pchi2_old+prod
            prod=prod*x/DBLE(FLOAT(i))
         END DO
         pchi2_old=1.D0-DEXP(-x)*pchi2_old
      ELSE                      ! odd degrees of freedom
         IF (x.ge.200.D0) THEN
            pchi2_old=1.D0
         ELSE
            c=1.D0
            pchi2_old=1.D0
            aa=a
 1          aa=aa+1.D0
            c=c*x/aa
            pchi2_old=pchi2_old+c
            IF (c/pchi2_old.gt.err) GO TO 1
            f=(x**a)*DEXP(-x)/gamma(a)
            pchi2_old=f*pchi2_old
         END IF
      END IF
      RETURN
      END

c.......................................................................

      FUNCTION qchi2_old(a,x)
      IMPLICIT NONE
      INTEGER i, iteven, ndeg
      REAL*8 qchi2_old, a, x, gamma, prod, err, rest, f, c, aa
      PARAMETER (err=5.D-7)
      EXTERNAL gamma

      IF (x.lt.0.D0.or.a.le.0.D0) STOP 
     .     'Bad input for incomplete gamma function Q'
      ndeg=INT(a*2.D0)
      rest=DMOD(a*2.D0,2.D0)
      
      IF (rest.lt.0.001D0) THEN ! even degrees of freedom
         iteven=ndeg/2
         qchi2_old=0.D0
         prod=1.D0
         DO i=1,iteven
            qchi2_old=qchi2_old+prod
            prod=prod*x/DBLE(FLOAT(i))
         END DO
         qchi2_old=DEXP(-x)*qchi2_old
      ELSE                      ! odd degrees of freedom
         IF (x.ge.200.D0) THEN
            qchi2_old=0.D0
         ELSE
            c=1.D0
            qchi2_old=1.D0
            aa=a
 1          aa=aa+1.D0
            c=c*x/aa
            qchi2_old=qchi2_old+c
            if (c/qchi2_old.gt.err) GO TO 1
            f=(x**a)*DEXP(-x)/gamma(a)
            qchi2_old=1.D0-f*qchi2_old
         END IF
      END IF
      RETURN
      END

c.......................................................................

      FUNCTION gamma(x)
      IMPLICIT NONE
      INTEGER i
      REAL*8 x, gamma, xx, z
      REAL*8 coeff(6), fact
      DATA coeff/76.18009172947146D0,-86.50532032941677D0,
     &     24.01409824083091D0,-1.231739572450155D0,
     &     0.1208650973866179D-2,-0.5395239384953D-5/
      fact=1.000000000190015D0
      z=x
      DO i=1,6
         z=z+1.D0
         fact=fact+coeff(i)/z
      END DO
      xx=x+5.5D0
      gamma=xx**(x+0.5D0)*DEXP(-xx)*DSQRT(2.D0*DACOS(-1.D0))*fact
      RETURN
      END

c.......................................................................

      FUNCTION zero(func,xl,xu,err)
      IMPLICIT NONE
      REAL*8 zero, func, xl, xu, x1, x2, xnew, err, test, errp
      INTEGER i, itmax
      PARAMETER (itmax=5000)
      EXTERNAL func
      IF (func(xl)*func(xu).gt.0.D0) THEN
         STOP ' ahi! zero non bracketed ...'
      END IF
      x1=xl
      x2=xu
      DO i=1,itmax
         xnew=x2-(func(x2)*(x1-x2))/(func(x1)-func(x2))
         IF (x1+x2.ne.0.) THEN
            errp=DABS((x2-x1)/(x2+x1))*100.D0
         END IF
         test=func(x1)*func(xnew)
         IF (test.eq.0.D0) THEN
            errp=0.D0
         ELSE
            IF (test.lt.0.D0) THEN
               x2=xnew
            ELSE
               x1=xnew
            END IF
         END IF
         IF (errp.le.err) GO TO 20
      END DO
 20   zero=xnew
      RETURN
      END

c.......................................................................

      SUBROUTINE sort2(n,arr,brr)
      INTEGER n,M,NSTACK
      REAL*8 arr(n),brr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL*8 a,b,temp
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          b=brr(j)
          do 11 i=j-1,1,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
            brr(i+1)=brr(i)
11        continue
          i=0
2         arr(i+1)=a
          brr(i+1)=b
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        temp=brr(k)
        brr(k)=brr(l+1)
        brr(l+1)=temp
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
          temp=brr(l+1)
          brr(l+1)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
          temp=brr(l)
          brr(l)=brr(ir)
          brr(ir)=temp
        endif
        if(arr(l+1).gt.arr(l))then
          temp=arr(l+1)
          arr(l+1)=arr(l)
          arr(l)=temp
          temp=brr(l+1)
          brr(l+1)=brr(l)
          brr(l)=temp
        endif
        i=l+1
        j=ir
        a=arr(l)
        b=brr(l)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        temp=brr(i)
        brr(i)=brr(j)
        brr(j)=temp
        goto 3
5       arr(l)=arr(j)
        arr(j)=a
        brr(l)=brr(j)
        brr(j)=b
        jstack=jstack+2
        if(jstack.gt.NSTACK) STOP 'NSTACK too small in sort2'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ]2#1.

c.......................................................................

      SUBROUTINE sort(n,arr)
      INTEGER n,M,NSTACK
      REAL*8 arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,ir,j,jstack,k,l,istack(NSTACK)
      REAL*8 a,temp
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 12 j=l+1,ir
          a=arr(j)
          do 11 i=j-1,1,-1
            if(arr(i).le.a)goto 2
            arr(i+1)=arr(i)
11        continue
          i=0
2         arr(i+1)=a
12      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l+1).gt.arr(l))then
          temp=arr(l+1)
          arr(l+1)=arr(l)
          arr(l)=temp
        endif
        i=l+1
        j=ir
        a=arr(l)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 3
5       arr(l)=arr(j)
        arr(j)=a
        jstack=jstack+2
        if(jstack.gt.NSTACK) STOP 'NSTACK too small in sort'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ]2#1.

c NR gammp renamed pchi2 ...............................................

      FUNCTION pchi2(a,x)
      REAL*8 a,pchi2,x
CU    USES gcf,gser
      REAL*8 gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.) STOP 'bad arguments in pchi2'
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        pchi2=gamser
      else
        call gcf(gammcf,a,x,gln)
        pchi2=1.-gammcf
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ]2#1.

c NR gammq renamed qchi2 ...............................................

      FUNCTION qchi2(a,x)
      REAL*8 a,qchi2,x
CU    USES gcf,gser
      REAL*8 gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.) STOP 'bad arguments in qchi2'
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        qchi2=1.-gamser
      else
        call gcf(gammcf,a,x,gln)
        qchi2=gammcf
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 0!+).


      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL*8 a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.D-7)
CU    USES gammln
      INTEGER n
      REAL*8 ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
        if (x.lt.0.) STOP 'x < 0 in gser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      STOP 'a too large, ITMAX too small in gser'
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 0!+).


      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL*8 a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.D-7,FPMIN=1.D-30)
CU    USES gammln
      INTEGER i
      REAL*8 an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      STOP 'a too large, ITMAX too small in gcf'
1     gammcf=exp(-x+a*log(x)-gln)*h
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 0!+).


      FUNCTION gammln(xx)
      REAL*8 gammln,xx
      INTEGER j
      REAL*8 ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software 0!+).
c.......................................................................
